VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cLine"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'  ==========================================
'  Dijkstra's algorithm to find Shortest Path
'  ==========================================
'
' E.W. Dijkstra is a Dutch professor in Computer
' Science, who did a lot of research in graphs.
'
' Dijkstra's algorithm is of use when working with
' directional graphs. It constructs the shortest path
' between a starting-node and a goal-node.
' It is assumed that every link between two nodes
' has a certain cost, and this algorithm finds the
' path between the two given nodes with the lowest cost.
'
' The idea of this VB project was to show the
' work of this algorithm in a visual way.
'
'    Screen-shot: dijkstra.gif
'
'
'    Visit my Homepage:
'    http://www.geocities.com/emu8086/vb/
'
'
'    Last Update: Saturday, July 20, 2002
'
'
'    Copyright 2002 Alexander Popov Emulation Soft.
'               All rights reserved.
'        http://www.geocities.com/emu8086/


Option Explicit

Public theObjectLine As Line

'local variable(s) to hold property value(s)
Private mvarsFrom As String 'local copy
Private mvarsTo As String 'local copy
'local variable(s) to hold property value(s)
Private mvarbShowArrow As Boolean 'local copy

Public Property Let sCaption(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.sCaption = 5
    Form1.lblLineCap(theObjectLine.index).Caption = vData
End Property


Public Property Get sCaption() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.sCaption
    sCaption = Form1.lblLineCap(theObjectLine.index).Caption
End Property




Public Property Let bShowArrow(ByVal vData As Boolean)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.showArrow = 5
    mvarbShowArrow = vData
End Property


Public Property Get bShowArrow() As Boolean
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.showArrow
    bShowArrow = mvarbShowArrow
End Property




Public Property Let sTo(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.sTo = 5
    mvarsTo = vData
End Property


Public Property Get sTo() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.sTo
    sTo = mvarsTo
End Property



Public Property Let sFrom(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.sFrom = 5
    mvarsFrom = vData
End Property


Public Property Get sFrom() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.sFrom
    sFrom = mvarsFrom
End Property

